if not is_game_single_player then return end

cutscene_timer = nil
cutscene_timer_pause = false

local function cutscene_end()
    textbox = nil
    cutscene_timer = nil
end

local function string_without_hex(name)
    local s = ''
    local inSlash = false
    for i = 1, #name do
        local c = name:sub(i,i)
        if c == '\\' then
            inSlash = not inSlash
        elseif not inSlash then
            s = s .. c
        end
    end
    return s
end

local cutscenes = {
    [1] = {
        [1] = function()
            stop_all_music()
            audio_sample_play(SOUND_LONG_PIPE, gMarioStates[0].pos, 1)
            custom_mario_state_fields.inactive = true
            black_screen = true
        end,
        [100] = function() audio_stream_play(PATHETIC_LUIGI, true, 0.5) create_textbox("Nice to see you again!", 1) end,
        [150] = function() create_textbox("It's been quite a while.", 1) end,
        [200] = function() create_textbox("You've destroyed my factory,>killed Golden Sigma,>and disrespected me.", 1) end,
        [225] = function() create_textbox("I have no idea why you did>any of this.", 1) end,
        [250] = function() create_textbox("You are an atroctious person.", 1) end,
        [375] = function() create_textbox("But", 1) end,
        [420] = function() create_textbox("Despite all of that", 1) end,
        [440] = function() create_textbox("I've invited you to a little humble>gathering!", 1) end,
        [441] = function() create_textbox("I've even invited my friends!", 1) end,
        [500] = function() create_textbox("However, theres a potential...>side effect.", 1) end,
        [550] = function() create_textbox("Thats you...", 1) end,
        [551] = function() stop_all_music() create_textbox("DYING! =", 1) end,
        [580] = function() black_screen = false custom_mario_state_fields.inactive = false warp_to_level(LEVEL_WF, 1, 1) cutscene_end() end
    },
    [2] = {
        [1] = function()
            stop_all_music()
            audio_sample_play(SOUND_LONG_PIPE, gMarioStates[0].pos, 1)
            custom_mario_state_fields.inactive = true
            black_screen = true
        end,
        [100] = function() audio_stream_play(PATHETIC_LUIGI, true, 0.5) create_textbox("Nice to see you again!", 1) end,
        [150] = function() create_textbox("You've destroyed my factory,>killed Golden Sigma,>and disrespected me.", 1) end,
        [175] = function() create_textbox("Despite all of that", 1) end,
        [200] = function() create_textbox("I've invited you to a gathering!", 1) end,
        [215] = function() create_textbox("I've even invited my friends!", 1) end,
        [225] = function() stop_all_music() create_textbox("PREPARE TO DIE! =", 1) end,
        [230] = function() black_screen = false custom_mario_state_fields.inactive = false warp_to_level(LEVEL_WF, 1, 1) cutscene_end() end
    },
    [3] = {
        [1] = function()
            stop_all_music()
            enable_time_stop()
        end,
        [75] = function()
            play_transition(WARP_TRANSITION_FADE_INTO_COLOR, 25, 0, 0, 0)
        end,
        [100] = function() black_screen = true custom_mario_state_fields.inactive = true audio_stream_play(GOLDEN_DEFEAT, true, 1) end,
        [120] = function() create_textbox("You killed me...", 2) end,
        [150] = function() create_textbox("I... i really thought i could beat you.", 2) end,
        [175] = function() create_textbox("I guess it's my time to go anyway.", 2) end,
        [200] = function() create_textbox("But, please...", 2) end,
        [210] = function() create_textbox("I don't have much time left>so i'll make this quick,", 2) end,
        [215] = function() create_textbox("Don't continue, Please spare Wega.", 2) end,
        [225] = function() create_textbox("He's forgiving, and kind...", 2) end,
        [245] = function() create_textbox("I beg you, please.", 2) end,
        [275] = function() create_textbox("Goodbye " .. string_without_hex(gNetworkPlayers[0].name) .. "...", 2) end,
        [400] = function() big_events_table.golden_sigma_killed = true mod_storage_save_event() audio_stream_stop(GOLDEN_DEFEAT) disable_time_stop() black_screen = false custom_mario_state_fields.inactive = false warp_to_level(LEVEL_DDD, 1, 1) cutscene_end() end
    },
    [4] = {
        [1] = function() custom_mario_state_fields.inactive = true sigma_cutscene = true audio_stream_play(GOLDEN_TALK, true, 1) end,
        [75] = function() create_textbox("I have been waiting for you...", 2) end,
        [100] = function() create_textbox("You destroyed Wega's factory.", 2) end,
        [120] = function() create_textbox("May i ask why?", 2) end,
        [150] = function() create_textbox("You had no reason to.", 2) end,
        [175] = function() create_textbox("I shall stop you.", 2) play_transition(WARP_TRANSITION_FADE_INTO_COLOR, 25, 0, 0, 0) audio_stream_stop(GOLDEN_TALK) end,
        [200] = function() play_transition(WARP_TRANSITION_FADE_FROM_COLOR, 25, 0, 0, 0) sigma_cutscene = false golden_sigma_battle_in_session = true custom_mario_state_fields.inactive = false audio_stream_play(GOLDEN_BOSSFIGHT, true, 1) cutscene_end() end
    }
}

local current_cutscene = 1

local cutscenes_played = {}

function check_if_cutscene_played(cutscene)
    for i = 1, #cutscenes_played do
        if cutscenes_played[i] == cutscene then
            return true
        end
    end

    return false
end

function cutscene_start(cutscene)
    current_cutscene = cutscene
    cutscene_timer = 0
    cutscene_timer_pause = false

    table.insert(cutscenes_played, cutscene)
end

local function on_update()
    local n = gNetworkPlayers[0]

    if cutscene_timer ~= nil and not cutscene_timer_pause then
        cutscene_timer = cutscene_timer + 1

        if cutscenes[current_cutscene][cutscene_timer] then
            cutscenes[current_cutscene][cutscene_timer]()  -- Execute the function
        end
    end
end

local function before_mario_update(m)
    if textbox ~= nil then
        if m.controller.buttonPressed & A_BUTTON ~= 0 then
            textbox = nil
            cutscene_timer_pause = false
        end
    end
end

hook_event(HOOK_UPDATE, on_update)
hook_event(HOOK_BEFORE_MARIO_UPDATE, before_mario_update)