-- 144 is total width
-- 72 is half width

if not is_game_single_player then return end

local TEX_MALTIGI_HEALTH_CIRC = get_texture_info('maltigihealth_circ')
local TEX_MALTIGI_HEALTH_CIRC2 = get_texture_info('maltigihealth_circ2')
local TEX_MALTIGI_HEALTH_BAR = get_texture_info('maltigihealth_bar')

local TEX_SPRINT_BAR_CIRC = get_texture_info('sprintbar_circ')
local TEX_SPRINT_BAR_CIRC2 = get_texture_info('sprintbar_circ2')
local TEX_SPRINT_BAR = get_texture_info('sprintbar')

local TEX_HORRIFIC_MARIO = get_texture_info('horrificmario')

local TEX_WINGA = get_texture_info('winga')

local minutetimer = 1728

winga = false
black_screen = false

function render_colored_text_centered(text, x, y, scale, spacing_factor, font) -- Most helpful function of 2024 [ChatGPT wrote this, im sorry, if I wrote this it would be MUCH worse (assuming i even could)]
    local default_color = {255, 255, 255, 255}

    djui_hud_set_font(font)

    local current_color = default_color
    local segments = {}
    local total_text_width = 0

    local pattern = "(.-)\\#(%x%x%x%x%x%x)\\(.*)"

    local function add_segment(text_segment, color)
        local segment_width = djui_hud_measure_text(text_segment) * scale * spacing_factor
        table.insert(segments, {text = text_segment, color = color, width = segment_width})
        total_text_width = total_text_width + segment_width
    end

    while #text > 0 do
        local text_segment, color_code, remaining_text = string.match(text, pattern)

        if color_code then

            if text_segment and #text_segment > 0 then
                add_segment(text_segment, current_color)
            end

            current_color = {
                tonumber(color_code:sub(1, 2), 16),
                tonumber(color_code:sub(3, 4), 16),
                tonumber(color_code:sub(5, 6), 16),
                255
            }
            text = remaining_text
        else
            add_segment(text, current_color)
            break
        end
    end

    local start_x = x - (total_text_width / 2)

    for _, segment in ipairs(segments) do
        djui_hud_set_color(segment.color[1], segment.color[2], segment.color[3], segment.color[4])
        djui_hud_print_text(segment.text, start_x, y, scale)
        start_x = start_x + segment.width
    end
end

local function boss_health_bar(boss_name, hurt_counter, health, max_health)
    djui_hud_set_resolution(RESOLUTION_N64)

    local width_center = (djui_hud_get_screen_width() / 2)
    local random_x = math.random(-4, 4) * hurt_counter
    local random_y = math.random(-4, 4) * hurt_counter

    djui_hud_set_color(255, 255, 255, 255)

    djui_hud_render_texture(TEX_MALTIGI_HEALTH_CIRC, (width_center - 72) + random_x, 16 + random_y, 1, 1)
    djui_hud_render_texture(TEX_MALTIGI_HEALTH_CIRC2, (width_center + 64) + random_x, 16 + random_y, 1, 1)

    djui_hud_render_texture(TEX_MALTIGI_HEALTH_BAR, (width_center - 64) + random_x, 16 + random_y, 1, 1)

    djui_hud_print_text(boss_name, (width_center - ((djui_hud_measure_text(boss_name) * 0.30) / 2)) + random_x, 20 + random_y, 0.30)

    djui_hud_set_color(0, 0, 0, 75)

    djui_hud_render_rect(((width_center - 64) + (health / (max_health / 128))) + random_x, 16 + random_y, 128 - (health / (max_health / 128)), 16)
end

local function render_boss_health_bars()
    local maltigi = obj_get_first_with_behavior_id(id_bhvMaltigi)
    local sigma = obj_get_first_with_behavior_id(id_bhvGoldenSigma)

    if maltigi then
        boss_health_bar('MALTIGA', maltigi.oHurtCounter, maltigi.oHealth, maltigi.oMaxHealth)
    end

    if sigma then
        boss_health_bar('GOLDEN SIGMA', sigma.oHurtCounter, sigma.oHealth, sigma.oMaxHealth)
    end
end

local function render_sprint_bar()
    djui_hud_set_resolution(RESOLUTION_N64)

    djui_hud_set_color(255, 255, 255, 255)

    local height = djui_hud_get_screen_height()

    local sprint_bar_offset_x = 0
    local sprint_bar_offset_y = 8

    djui_hud_render_texture(TEX_SPRINT_BAR_CIRC, 8 + sprint_bar_offset_x, (height - 24) + sprint_bar_offset_y, 0.5, 0.5)
    djui_hud_render_texture(TEX_SPRINT_BAR_CIRC2, (64 + 12) + sprint_bar_offset_x, (height - 24) + sprint_bar_offset_y, 0.5, 0.5)

    djui_hud_render_texture(TEX_SPRINT_BAR, 12 + sprint_bar_offset_x, (height - 24) + sprint_bar_offset_y, 0.5, 0.5)

    -- render the name

    djui_hud_set_color(0, 0, 0, 125)

    djui_hud_render_rect((12 + sprint_bar_offset_x) + 1, ((height - 24) + sprint_bar_offset_y) + 1, (custom_mario_state_fields.sprintTimer / 4) - 2, 8 - 2)
end

local function render_timer()
    if level_timer > 192 and level_timer < 1920 then
        minutetimer = minutetimer - 1

        render_colored_text_centered(tostring(math.ceil(minutetimer / 30)), djui_hud_get_screen_width() / 2, 32, 2, 1, FONT_MENU)
    elseif level_timer >= 1920 then

    end
end

local function display_horrific_mario_func()
    local width = djui_hud_get_screen_width()
    local height = djui_hud_get_screen_height()
    local flicker = math.random(170, 255)

    djui_hud_set_color(0, 0, 0, 255)

    djui_hud_render_rect(0, 0, width + 5, height + 5)

    djui_hud_set_color(flicker, flicker, flicker, 255)

    djui_hud_render_texture(TEX_HORRIFIC_MARIO, (width / 2) - (TEX_HORRIFIC_MARIO.width / 4), (height / 2) - (TEX_HORRIFIC_MARIO.height / 4), 0.5, 0.5)
end

local function winga_end_screen()
    local width = djui_hud_get_screen_width()
    local height = djui_hud_get_screen_height()

    djui_hud_set_color(255, 255, 255, 255)

    djui_hud_render_texture(TEX_WINGA, 0, 0, width / 256, height / 256)
end


local function show_black_screen()
    local width = djui_hud_get_screen_width()
    local height = djui_hud_get_screen_height()

    djui_hud_set_color(0, 0, 0, 255)

    djui_hud_render_rect(0, 0, width + 5, height + 5)
end

local function on_hud_render()
    hud_hide()

    if factory_cutscene or sigma_cutscene or in_menu then return end

    if black_screen then
        show_black_screen()
    end

    if active_jumpscare then return end

    if gNetworkPlayers[0].currLevelNum == LEVEL_TTM then
        render_timer()

        if level_timer == math.floor(6.40 * 30) then
            play_transition(WARP_TRANSITION_FADE_FROM_COLOR, 30, 0, 0, 0)
        end
    end

    render_sprint_bar()

    if display_horrific_mario then
        display_horrific_mario_func()
    end

    if winga then
        winga_end_screen()
    end

    render_boss_health_bars()
end

local function level_init()
    minutetimer = 1728
end

hook_event(HOOK_ON_HUD_RENDER_BEHIND, on_hud_render)
hook_event(HOOK_ON_LEVEL_INIT, level_init)