if not is_game_single_player then return end

local trollface_jumpscare = 0

active_jumpscare = false

TEX_GOLDEN_SIGMA_JUMPSCARE = get_texture_info('golden_sigma')
TEX_MALTIGA_JUMPSCARE = get_texture_info('maltiga')
TEX_WEGA_JUMPSCARE = get_texture_info('wega')

local jumpscare_image = TEX_WEGA_JUMPSCARE
local jumpscare_timer = 0

SOUND_JUMPSCARE = audio_sample_load("main_character_jumpscare.ogg")

local function draw_trollface_jumpscare()
    local scale = 24

    djui_hud_set_color(255, 255, 255, trollface_jumpscare)
    djui_hud_render_texture(TEX_TROLLFACE, (djui_hud_get_screen_width() / 2) - ((scale / 2) * TEX_TROLLFACE.width), (djui_hud_get_screen_height() / 2) - ((scale / 2) * TEX_TROLLFACE.height), scale, scale)

    if trollface_jumpscare > 0 then
        trollface_jumpscare = trollface_jumpscare - 5
    else
        trollface_jumpscare = 0
    end
end

local function jumpscares()
    draw_trollface_jumpscare()

    if not active_jumpscare then return end

    if jumpscare_timer > 30 then
        local width = djui_hud_get_screen_width()
        local height = djui_hud_get_screen_height()

        local random = clampf(math.abs(math.sin(level_timer)) * 250, 0, 210) - 25 + math.random(1, 25)

        local scale = height / jumpscare_image.height

        djui_hud_set_color(random, random, random, 255)

        djui_hud_render_texture(jumpscare_image, width / 2 - ((jumpscare_image.width / 2) * scale), height / 2 - ((jumpscare_image.height / 2) * scale), scale, scale)
    end

    if jumpscare_timer > 0 then
        jumpscare_timer = jumpscare_timer - 1
    end
end

function create_troll_jumpscare()
    trollface_jumpscare = 255
end

function create_jumpscare(image)
    audio_sample_play(SOUND_JUMPSCARE, gMarioStates[0].pos, 1)
    stop_all_music()

    custom_mario_state_fields.inactive = true

    jumpscare_image = image
    jumpscare_timer = 60

    trollface_jumpscare = 0

    active_jumpscare = true

    black_screen = true

    gMarioStates[0].pos.y = gMarioStates[0].pos.y + 1500

    enable_time_stop_including_mario()
end

local function on_death()
    local player = gNetworkPlayers[0]

    if player.currLevelNum == LEVEL_SA then return end

    if player.currLevelNum == LEVEL_WF then
        create_jumpscare(TEX_MALTIGA_JUMPSCARE)
    elseif player.currLevelNum == LEVEL_BITDW then
        create_jumpscare(TEX_GOLDEN_SIGMA_JUMPSCARE)
    else
        create_jumpscare(TEX_WEGA_JUMPSCARE)
    end

    return false
end

local function mario_update()
    local m = gMarioStates[0]

    if m.health <= 0xFF and not active_jumpscare then
        on_death()

        m.health = 0x880

        return
    end

    if jumpscare_timer == 0 and active_jumpscare then
        warp_to_start_level()
        disable_time_stop_including_mario()

        custom_mario_state_fields.inactive = false
        active_jumpscare = false
        black_screen = false

        play_transition(WARP_TRANSITION_FADE_FROM_COLOR, 150, 0, 0, 0)
    end
end

hook_event(HOOK_ON_HUD_RENDER_BEHIND, jumpscares)
hook_event(HOOK_MARIO_UPDATE, mario_update)