if not is_game_single_player then return end

local fov = 40
local fov_2 = 50

factory_cutscene = false
sigma_cutscene = false

local function factory_cutscene_update()
    if not factory_cutscene then return end

    local factory_cutscene_stage = 1

    if level_timer > (3.20 * 30) then
        factory_cutscene_stage = 2
    end

    if factory_cutscene_stage == 1 then
        local l = gLakituState
        local monitor = obj_get_first_with_behavior_id(id_bhvMonitor)

        l.pos.x = 6000
        l.pos.y = 1450
        l.pos.z = 5350

        l.goalFocus.x = monitor.oPosX
        l.goalFocus.y = monitor.oPosY + 64
        l.goalFocus.z = monitor.oPosZ

        l.focus.x = monitor.oPosX
        l.focus.y = monitor.oPosY + 64
        l.focus.z = monitor.oPosZ

        l.curFocus.x = monitor.oPosX
        l.curFocus.y = monitor.oPosY + 64
        l.curFocus.z = monitor.oPosZ

        set_override_fov(fov)

        fov = fov + 0.10

        skip_camera_interpolation()
    elseif factory_cutscene_stage == 2 then
        local l = gLakituState
        local door = obj_get_first_with_behavior_id(id_bhvBreakDoor)

        l.pos.x = 64 * 100
        l.pos.y = 6 * 100
        l.pos.z = 58 * 100

        l.goalFocus.x = door.oPosX
        l.goalFocus.y = door.oPosY + 64
        l.goalFocus.z = door.oPosZ

        l.focus.x = door.oPosX
        l.focus.y = door.oPosY + 64
        l.focus.z = door.oPosZ

        l.curFocus.x = door.oPosX
        l.curFocus.y = door.oPosY + 64
        l.curFocus.z = door.oPosZ

        if level_timer == math.floor((6.40 * 30) - 30) then
            play_transition(WARP_TRANSITION_FADE_INTO_COLOR, 30, 0, 0, 0)
        end

        set_override_fov(100)
    end
end

local function golden_sigma_cutscene_update()
    if not sigma_cutscene then return end

    local l = gLakituState
    local golden_sigma = obj_get_first_with_behavior_id(id_bhvGoldenSigma)

    l.pos.x = -1000
    l.pos.y = 500
    l.pos.z = 0

    l.goalFocus.x = golden_sigma.oPosX
    l.goalFocus.y = golden_sigma.oPosY + 64
    l.goalFocus.z = golden_sigma.oPosZ

    l.focus.x = golden_sigma.oPosX
    l.focus.y = golden_sigma.oPosY + 64
    l.focus.z = golden_sigma.oPosZ

    l.curFocus.x = golden_sigma.oPosX
    l.curFocus.y = golden_sigma.oPosY + 64
    l.curFocus.z = golden_sigma.oPosZ

    set_override_fov(fov_2)

    fov_2 = approach_f32_asymptotic(fov_2, 70, 0.005)
end

local function update()
    factory_cutscene_update()
    golden_sigma_cutscene_update()
end

local function reset_variables()
    fov = 40
    fov_2 = 50
end

hook_event(HOOK_UPDATE, update)
hook_event(HOOK_ON_LEVEL_INIT, reset_variables)