-- name: Wega's Wansion!
-- description: Wega's Wansion is a romhack solely developed by me! Birdekek. \n\nThe only thing not developed by me is the Gore / Hardmode Gibs made by TheIncredibleHolc, which i got permission to use. Thanks Holc!\n\nDue to time constraints, this romhack will unfortunately not work in multiplayer, Sorry!
-- incompatible: romhack gamemode

if not is_game_single_player then return end

E_MODEL_TILE_FLOOR = smlua_model_util_get_id("tile_floor_geo")
E_MODEL_WEGA_PLUSHIE = smlua_model_util_get_id("wega_plush_geo")
E_MODEL_MALTIGI = smlua_model_util_get_id("maltigi_geo")
E_MODEL_WEGA = smlua_model_util_get_id("wega_geo")
E_MODEL_ROCK_PLATFORM = smlua_model_util_get_id("rock_platform_geo")
E_MODEL_RUNNING_WEGA = smlua_model_util_get_id("running_wega_geo")

COL_TILE_FLOOR = smlua_collision_util_get("tile_floor_collision")
COL_ROCK_PLATFORM = smlua_collision_util_get("rock_platform_collision")

local TILE_NONE = 0
local TILE_FLOOR = 1
local map_tiles = {}
local wega_plush_counter = 0
local deathing_timer = 0
display_horrific_mario = false
level_timer = 0

SOUND_WEGA_PLUSHIE_PICKUP = audio_sample_load("wegaplushiepickup.ogg")
SOUND_WEGA_PLUSHIE_THROW = audio_sample_load("wegaplushiethrow.ogg")
SOUND_MALTIGI_SCREAM = audio_sample_load("maltigiscream.ogg")
SOUND_MALTIGI_DEATH = audio_sample_load("maltigideath.ogg")
SOUND_RUNNING_WEGA_BYE_BYE = audio_sample_load("runningwegabyebye.ogg")
SOUND_RUNNING_WEGA_LAUGH_1 = audio_sample_load("runningwegalaugh1.ogg")
SOUND_RUNNING_WEGA_LAUGH_2 = audio_sample_load("runningwegalaugh2.ogg")
SOUND_RUNNING_WEGA_LAUGH_3 = audio_sample_load("runningwegalaugh3.ogg")
SOUND_RUNNING_WEGA_RUNNING = audio_sample_load("runningwegarunning.ogg")
SOUND_RUNNING_WEGA_RUNNING_START = audio_sample_load("runningwegarunningstart.ogg")
SOUND_RUNNING_WEGA_RUNNING_STOP = audio_sample_load("runningwegarunningstop.ogg")
SOUND_RUNNING_WEGA_DEATH = audio_sample_load("runningwegadeath.ogg")
SOUND_LONG_PIPE = audio_sample_load("long_pipe.ogg")
SOUND_SMB_BLOCK_BREAK = audio_sample_load("smb_block_break.ogg")
SOUND_DOOR_MOVE = audio_sample_load("doormove.ogg")
SOUND_WIN = audio_sample_load("happywin.ogg")
SOUND_GREWSOME_DEATH = audio_sample_load("grewsome.ogg")
FACTORY_CUTSCENE_INTRO = audio_stream_load("wegafactorycutscene.ogg")

gGlobalSyncTable.seed = math.random(1000000000000000, 9999999999999999)

big_events_table = {
    wegas_factory_destroyed = false,
    golden_sigma_killed = false,
    maltiga_defeated = false,
}

local function grewsome_death()
    stop_all_music()
    display_horrific_mario = true
    deathing_timer = 150
end

-- Initialize floor tile behavior
local function bhv_tile_floor_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    o.oCollisionDistance = 7000
    o.collisionData = COL_TILE_FLOOR
    o.oAngleVelYaw = 0
    o.header.gfx.skipInViewCheck = true
    obj_scale(o, 2)
end

local function bhv_tile_floor_loop(o)
    load_object_collision_model()
end

local function bhv_wega_plushie_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE

    o.oCollisionDistance = 7000
    o.header.gfx.skipInViewCheck = true

    o.oFaceAngleYaw = math.random(0, 65536)

    o.oAngleVelYaw = 512

    o.oForwardVel = 0

    obj_set_hitbox_radius_and_height(o, 64, 128)

    --network_init_object(o, true, nil)
end

local function bhv_wega_plushie_loop(o)
    local m = gMarioStates[0]
    local mario = 0

    if o.heldByPlayerIndex then
        mario = network_local_index_from_global(o.heldByPlayerIndex)
    end

    if o.oAction == 0 then
        if obj_check_hitbox_overlap(m.marioObj, o) then
            play_sound(SOUND_MENU_CLICK_FILE_SELECT, {x=o.oPosX,y=o.oPosY,z=o.oPosZ})

            o.oAction = 1
        end
    elseif o.oAction == 1 then
        o.oAngleVelYaw = o.oAngleVelYaw + 256

        o.oPosY = o.oPosY + 16

        if o.oTimer >= 5 then
            obj_mark_for_deletion(o)
        end
    elseif o.oAction == 2 then
        o.oAngleVelYaw = 0
        o.oFaceAngleYaw = 0

        o.oPosY = gMarioStates[mario].pos.y + 145

        o.oPosX = gMarioStates[mario].pos.x + (-256 * sins(gMarioStates[mario].faceAngle.y))
        o.oPosZ = gMarioStates[mario].pos.z + (-256 * coss(gMarioStates[mario].faceAngle.y))
    elseif o.oAction == 3 then
        o.oForwardVel = 50

        local maltigi = obj_get_first_with_behavior_id(id_bhvMaltigi)
        local running_wega = obj_get_first_with_behavior_id(id_bhvRunningWega)

        if maltigi then
            if obj_check_hitbox_overlap(o, maltigi) then
                maltigi.oAction = 1
                maltigi.oTimer = 0

                obj_mark_for_deletion(o)
            end
        end

        if running_wega then
            if obj_check_hitbox_overlap(o, running_wega) then
                running_wega.oAction = 3

                obj_mark_for_deletion(o)
            end
        end

        obj_compute_vel_from_move_pitch(o.oForwardVel)
        obj_move_xyz_using_fvel_and_yaw(o)
    elseif o.oAction == 4 then
        o.oAngleVelYaw = 409.60
    end

    if gNetworkPlayers[0].currLevelNum == LEVEL_WF then
        if dist_between_object_and_point(o, 0, 0, 0) > 7500 then
            play_sound(SOUND_MENU_HAND_DISAPPEAR, o.header.gfx.cameraToObject)
            obj_mark_for_deletion(o)
        end
    end

    o.oFaceAngleYaw = o.oFaceAngleYaw + o.oAngleVelYaw
end

local function bhv_wega_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.node.flags = o.header.gfx.node.flags | GRAPH_RENDER_BILLBOARD
	o.header.gfx.skipInViewCheck = true
    o.oGraphYOffset = 384

    obj_set_hitbox_radius_and_height(o, 128, 128)

	cur_obj_scale(1)
end

local function bhv_wega_loop(o)
    local pmario = nearest_mario_state_to_object(o)
    local m = gMarioStates[0]

    if o.oBehParams2ndByte == 2 then
        o.oAction = 1
    end

    if o.oAction == 0 then
        if o.oTimer > 120 then
            if pmario ~= nil then
                obj_rotate_towards_point(o, pmario.pos, 0, 0, 0, 0.01)
                o.oForwardVel = 48

                obj_compute_vel_from_move_pitch(o.oForwardVel)
                obj_move_xyz_using_fvel_and_yaw(o)
            end
        end

        if (o.oTimer % 10) == 0 and o.oTimer > 120 then
            audio_sample_play(SOUND_WEGA_SCREAM, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, (1 / (vec3f_dist(m.pos, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}) / 16384)) / 3)
        end

        if dist_between_objects(o, m.marioObj) < 345 and o.oTimer > 120 then
            m.health = 0xff
        end
    elseif o.oAction == 1 then -- Cutscene Wega
        if o.oTimer >= (3.20 * 30) then
            o.oForwardVel = approach_f32(o.oForwardVel, 100, 5, 5)
        end

        if o.oTimer >= (7 * 30) then
            obj_mark_for_deletion(o)
        end

        obj_move_xyz_using_fvel_and_yaw(o)
    elseif o.oAction == 2 then -- Island Wega
        if pmario ~= nil then
            obj_rotate_towards_point(o, pmario.pos, 0, 0, 0, 0.01)
            o.oForwardVel = 48

            obj_compute_vel_from_move_pitch(o.oForwardVel)
            obj_move_xyz_using_fvel_and_yaw(o)
        end

        if dist_between_objects(o, m.marioObj) < 345 then
            audio_sample_play(SOUND_GREWSOME_DEATH, {x = o.oPosX, y = o.oPosY, z = o.oPosZ}, 1)
            grewsome_death()

            obj_mark_for_deletion(o)
        end
    elseif o.oAction == 8 then
        -- dont really do anything :\
    end
end

local function bhv_maltigi_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.node.flags = o.header.gfx.node.flags | GRAPH_RENDER_BILLBOARD
	o.header.gfx.skipInViewCheck = true
    o.oGraphYOffset = 384
    o.oHurtCounter = 0
    o.oMaxHealth = 512
    o.oHealth = o.oMaxHealth

    obj_set_hitbox_radius_and_height(o, 64, 512)

	cur_obj_scale(1)
end

local function bhv_maltigi_loop(o)
    local pmario = nearest_mario_state_to_object(o)
    local m = gMarioStates[0]

    if o.oAction == 0 then
        o.oAnimState = 0

        if o.oTimer > 320 then
            if pmario ~= nil then
                o.oMoveAngleYaw = approach_s16_asymptotic(o.oMoveAngleYaw, obj_angle_to_object(o, pmario.marioObj), 0.15)
                o.oForwardVel = approach_s16_symmetric(o.oForwardVel, 48, 8) -- og 48

                obj_move_xyz_using_fvel_and_yaw(o)
            end
        end
    elseif o.oAction == 1 then
        if o.oTimer == 0 then
            audio_sample_play(SOUND_MALTIGI_SCREAM, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, 1)
            o.oHurtCounter = 1
        end

        if math.random(1, 2) == 1 then
            o.oAnimState = 1
        else
            o.oAnimState = 0
        end

        if o.oTimer >= 90 then
            o.oAction = 2
        end

        o.oForwardVel = 0
    elseif o.oAction == 2 then
        o.oAnimState = 0

        if pmario ~= nil then
            o.oMoveAngleYaw = approach_s16_asymptotic(o.oMoveAngleYaw, obj_angle_to_object(o, pmario.marioObj), 0.01)
            o.oForwardVel = approach_s16_symmetric(o.oForwardVel, 48, 8) -- og 48

            obj_move_xyz_using_fvel_and_yaw(o)
        end
    elseif o.oAction == 8 then
        -- dont really do anything :\
    end

    o.oHurtCounter = approach_f32(o.oHurtCounter, 0, 1, 0.05)
    o.oHealth = o.oHealth - o.oHurtCounter

	if dist_between_objects(o, m.marioObj) < 345 and (o.oTimer > 320 or o.oAction == 2) then
        m.health = 0xff
	end

    if o.oHealth <= 0 then
        audio_sample_play(SOUND_MALTIGI_DEATH, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, 2)
        audio_stream_stop(WEGALOVANIA_LOOP)

        big_events_table.maltiga_defeated = true
        mod_storage_save_event()

        enable_time_stop_including_mario()
        winga = true

        obj_mark_for_deletion(o)
    end
end

local function bhv_rock_platform_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true
    o.collisionData = COL_ROCK_PLATFORM

	cur_obj_scale(1)
end

local function bhv_rock_platform_loop(o)
    load_object_collision_model()
end

local function bhv_running_wega_init(o)
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
	o.header.gfx.skipInViewCheck = true

    smlua_anim_util_set_animation(o, 'running_wega_run_anim')

    o.oHomeX = math.random(-2280, 2280)
    o.oHomeZ = math.random(-2280, 2280)

    obj_set_hitbox_radius_and_height(o, 128, 256)

	cur_obj_scale(0.2)
end

local function bhv_running_wega_loop(o)
    if o.oAction ~= 8 then
        local m = nearest_mario_state_to_object(o)

        if (o.oTimer % 15) == 0 then
            play_sound(SOUND_ACTION_METAL_STEP, {x=o.oPosX,y=o.oPosY,z=o.oPosZ})
            o.oForwardVel = 300
        end

        if dist_between_objects(m.marioObj, o) > 512 then
            o.oForwardVel = approach_f32(o.oForwardVel, 0, 5, 75)
        else
            o.oForwardVel = approach_f32(o.oForwardVel, 0, 5, 60)
        end

        o.oPosY = 0 + (o.oTimer % 15)

        if o.oAction == 1 then
            if cur_obj_lateral_dist_from_obj_to_home(o) < 350 then
                o.oHomeX = math.random(-2280, 2280)
                o.oHomeZ = math.random(-2280, 2280)
            end

            o.oMoveAngleYaw = approach_s16_symmetric(o.oMoveAngleYaw, obj_angle_to_point(o, o.oHomeX, o.oHomeZ), 1024)

            if o.oTimer == 250 then
                audio_sample_play(SOUND_RUNNING_WEGA_BYE_BYE, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, 1)
            end

            if o.oTimer >= 300 then
                o.oAction = 2
            end
        elseif o.oAction == 2 then
            o.oMoveAngleYaw = approach_s16_symmetric(o.oMoveAngleYaw, obj_angle_to_object(o, m.marioObj), 2048)

            if o.oTimer == 1 then
                audio_sample_play(SOUND_RUNNING_WEGA_RUNNING_START, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, 1)
            end

            if o.oTimer > 15 then
                if ((o.oTimer - 15) % 60) == 1 then
                    if o.oTimer > 100 then
                        local stop_or_continue = math.random(1, 6)

                        if stop_or_continue == 4 then
                            audio_sample_play(SOUND_RUNNING_WEGA_RUNNING_STOP, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, 1)

                            o.oAction = 1
                        else
                            audio_sample_play(SOUND_RUNNING_WEGA_RUNNING, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, 1)
                        end
                    else
                        audio_sample_play(SOUND_RUNNING_WEGA_RUNNING, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, 1)
                    end
                end
            end
        elseif o.oAction == 3 then
            audio_sample_stop(SOUND_RUNNING_WEGA_BYE_BYE)
            audio_sample_stop(SOUND_RUNNING_WEGA_RUNNING)
            audio_sample_stop(SOUND_RUNNING_WEGA_RUNNING_START)

            audio_sample_play(SOUND_RUNNING_WEGA_DEATH, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, 1)

            obj_mark_for_deletion(o)
        end

        if dist_between_objects(m.marioObj, o) < 512 then
            local random_sound = math.random(1, 3)
            local maltigi = obj_get_first_with_behavior_id(id_bhvMaltigi)
            local random_x, random_z = math.random(-2280, 2280), math.random(-2280, 2280)

            audio_sample_stop(SOUND_RUNNING_WEGA_BYE_BYE)
            audio_sample_stop(SOUND_RUNNING_WEGA_RUNNING)
            audio_sample_stop(SOUND_RUNNING_WEGA_RUNNING_START)

            repeat
                random_x = math.random(-2280, 2280)
                random_z = math.random(-2280, 2280)
            until dist_between_object_and_point(maltigi, random_x, maltigi.oPosY, random_z) > 1024

            m.pos.x = random_x
            m.pos.z = random_z

            if m.playerIndex == gMarioStates[0].playerIndex then
                gFirstPersonCamera.yaw = obj_angle_to_object(m.marioObj, maltigi)

                if random_sound == 1 then
                    audio_sample_play(SOUND_RUNNING_WEGA_LAUGH_1, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, 1)
                elseif random_sound == 2 then
                    audio_sample_play(SOUND_RUNNING_WEGA_LAUGH_2, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, 1)
                elseif random_sound == 3 then
                    audio_sample_play(SOUND_RUNNING_WEGA_LAUGH_3, {x=o.oPosX,y=o.oPosY,z=o.oPosZ}, 1)
                end

                play_transition(WARP_TRANSITION_FADE_FROM_CIRCLE, 15, 0, 0, 0)
            end

            obj_mark_for_deletion(o)
        end

        obj_set_face_angle_to_move_angle(o)
        obj_move_xyz_using_fvel_and_yaw(o)
    else
        if (o.oTimer % 15) == 0 then
            play_sound(SOUND_ACTION_METAL_STEP, {x=o.oPosX,y=o.oPosY,z=o.oPosZ})
            o.oForwardVel = 300
        end
    end
end

id_bhvRockPlatform = hook_behavior(nil, OBJ_LIST_SURFACE, true, bhv_rock_platform_init, bhv_rock_platform_loop)
id_bhvWega = hook_behavior(nil, OBJ_LIST_GENACTOR, true, bhv_wega_init, bhv_wega_loop)
id_bhvMaltigi = hook_behavior(nil, OBJ_LIST_GENACTOR, true, bhv_maltigi_init, bhv_maltigi_loop)
id_bhvWegaPlushie = hook_behavior(nil, OBJ_LIST_GENACTOR, true, bhv_wega_plushie_init, bhv_wega_plushie_loop)
id_bhvRunningWega = hook_behavior(nil, OBJ_LIST_GENACTOR, true, bhv_running_wega_init, bhv_running_wega_loop)
id_bhvFloorTile = hook_behavior(nil, OBJ_LIST_SURFACE, true, bhv_tile_floor_init, bhv_tile_floor_loop)

local function on_level_init()
    local m = gMarioStates[0]

    stop_all_music()

    if gNetworkPlayers[0].currLevelNum == LEVEL_BOB then
        for tilex = 1, 16 do
            for tiley = 1, 16 do
                local posX = (tilex * 512) - 4096
                local posZ = (tiley * 512) - 4096
                local posY = 0
                spawn_non_sync_object(id_bhvFloorTile, E_MODEL_TILE_FLOOR, posX, posY, posZ, nil)
                spawn_non_sync_object(id_bhvWegaPlushie, E_MODEL_WEGA_PLUSHIE, posX, posY + 150, posZ, nil)
            end
        end

        spawn_non_sync_object(id_bhvWega, E_MODEL_WEGA, 0, 0, 0, nil)
    elseif gNetworkPlayers[0].currLevelNum == LEVEL_WF then
        audio_stream_play(WEGALOVANIA_START, false, 1)
        spawn_non_sync_object(id_bhvMaltigi, E_MODEL_MALTIGI, 0, 0, 0, nil)
    elseif gNetworkPlayers[0].currLevelNum == LEVEL_DDD then
        audio_stream_play(CASTLE_SONG, false, 0.75)
        audio_stream_play(FE_JUST_A_MILE_AWAY, true, 1.25)

        if not big_events_table.golden_sigma_killed or not big_events_table.wegas_factory_destroyed then
            local pipe = obj_get_first_with_behavior_id(id_bhvRetroPipe)

            if pipe then
                obj_mark_for_deletion(pipe)
            end
        end
    elseif gNetworkPlayers[0].currLevelNum == LEVEL_TTM then
        spawn_non_sync_object(id_bhvWeapon, E_MODEL_CROWBAR, m.pos.x, m.pos.y, m.pos.z, nil)

        audio_stream_play(BREAK_A_FACTORY, false, 1.25)

        audio_stream_play(FACTORY_CUTSCENE_INTRO, true, 1)

        factory_cutscene = true

        machines_destroyed = 0
    elseif gNetworkPlayers[0].currLevelNum == LEVEL_SA then
        spawn_non_sync_object(id_bhvFog, E_MODEL_FOG, gLakituState.pos.x, gLakituState.pos.y, gLakituState.pos.z, nil)

        audio_stream_play(ISLAND, false, 1.25)
    elseif gNetworkPlayers[0].currLevelNum == LEVEL_BITDW then
        if big_events_table.wegas_factory_destroyed then
            if not big_events_table.golden_sigma_killed then
                golden_sigma_battle_in_session = false
                cutscene_start(4)
            else
                local golden_sigma = obj_get_first_with_behavior_id(id_bhvGoldenSigma)

                obj_mark_for_deletion(golden_sigma)
            end
        else
            local golden_sigma = obj_get_first_with_behavior_id(id_bhvGoldenSigma)

            obj_mark_for_deletion(golden_sigma)
        end
    end

    level_timer = 0
end

local function mario_update(m)
    if m ~= gMarioStates[0] then return end

    level_timer = level_timer + 1

    if not obj_get_first_with_behavior_id(id_bhvWegaPlushie) and gNetworkPlayers[0].currLevelNum == LEVEL_BOB then
        warp_to_level(LEVEL_WF, 1, 1)
    end

    if gNetworkPlayers[0].currLevelNum == LEVEL_WF then
        if wega_plush_counter >= 120 and not obj_get_first_with_behavior_id(id_bhvWegaPlushie) then
            local mathrandomx = math.random(-2280, 2280)
            local mathrandomz = math.random(-2280, 2280)

            spawn_non_sync_object(id_bhvWegaPlushie, E_MODEL_WEGA_PLUSHIE, mathrandomx, 150, mathrandomz, function(o)
                o.oAction = 4
            end)
        end

        if not obj_get_first_with_behavior_id(id_bhvWegaPlushie) then
            wega_plush_counter = wega_plush_counter + 1
        else
            wega_plush_counter = 0
        end

        if math.random(1, 8192) == 128 and not obj_get_first_with_behavior_id(id_bhvRunningWega) then
            local mathrandomx = math.random(-2280, 2280)
            local mathrandomz = math.random(-2280, 2280)

            if vec3f_dist(m.pos, {x=mathrandomx,y=m.pos.y,z=mathrandomz}) > 1024 and obj_get_first_with_behavior_id(id_bhvMaltigi) then
                spawn_non_sync_object(id_bhvRunningWega, E_MODEL_RUNNING_WEGA, mathrandomx, 0, mathrandomz, function(o)
                    o.oAction = 1
                end)
            end
        end

        if not obj_get_first_with_behavior_id(id_bhvMaltigi) then
            local runwega = obj_get_first_with_behavior_id(id_bhvRunningWega)

            if runwega then
                obj_mark_for_deletion(runwega)
            end
        end
    end

    if gNetworkPlayers[0].currLevelNum == LEVEL_TTM then
        if level_timer < (6.40 * 30) then
            factory_cutscene = true

            custom_mario_state_fields.inactive = true
        else
            factory_cutscene = false

            if custom_mario_state_fields.inactive then
                custom_mario_state_fields.inactive = false
            end
        end

        if level_timer >= 64 * 30 and not big_events_table.wegas_factory_destroyed then
            warp_to_level(LEVEL_SA, 1, 1)
        end

        if machines_destroyed == 32 and level_timer > 16 and not big_events_table.wegas_factory_destroyed then
            audio_sample_play(SOUND_WIN, gMarioStates[0].pos, 1)
            audio_stream_stop(BREAK_A_FACTORY)
            big_events_table.wegas_factory_destroyed = true
            mod_storage_save_event()
        end
    end

    if gNetworkPlayers[0].currLevelNum == LEVEL_SA then
        if level_timer == (32 * 30) then
            if not obj_get_first_with_behavior_id(id_bhvWega) then
                spawn_non_sync_object(id_bhvWega, E_MODEL_WEGA, 0, 0, 0, function(obj)
                    obj.oAction = 2
                end)
            end
        end
    end

    if (m.controller.buttonPressed & A_BUTTON) ~= 0 then
        local wega_plush = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvWegaPlushie)

        if wega_plush then
            if wega_plush.oAction == 4 then
                local wega_plush_pos = {x=0,y=0,z=0}
                local width = djui_hud_get_screen_width()

                djui_hud_world_pos_to_screen_pos({x=wega_plush.oPosX,y=wega_plush.oPosY,z=wega_plush.oPosZ}, wega_plush_pos)

                if wega_plush_pos.x < width and wega_plush_pos.x > 0 and dist_between_objects(m.marioObj, wega_plush) < 512 then
                    wega_plush.heldByPlayerIndex = m.playerIndex
                    wega_plush.oAction = 2

                    audio_sample_play(SOUND_WEGA_PLUSHIE_PICKUP, {x=wega_plush.oPosX,y=wega_plush.oPosY,z=wega_plush.oPosZ}, 1)
                end

                return
            elseif wega_plush.oAction == 2 then
                wega_plush.oAction = 3
                wega_plush.oFaceAngleYaw = gFirstPersonCamera.yaw - 32768
                wega_plush.oMoveAngleYaw = gFirstPersonCamera.yaw - 32768

                wega_plush.oFaceAnglePitch = gFirstPersonCamera.pitch
                wega_plush.oMoveAnglePitch = gFirstPersonCamera.pitch

                audio_sample_play(SOUND_WEGA_PLUSHIE_THROW, {x=wega_plush.oPosX,y=wega_plush.oPosY,z=wega_plush.oPosZ}, 1)

                return
            end
        end
    end
end

local function update_timers()
    if deathing_timer > 0 then
        deathing_timer = deathing_timer - 1
    end

    if display_horrific_mario then
        custom_mario_state_fields.inactive = true
    end

    if deathing_timer == 0 and display_horrific_mario then
        display_horrific_mario = false
        custom_mario_state_fields.inactive = false
        warp_to_level(LEVEL_DDD, 1, 1)
    end
end

local function on_warp()
    if gNetworkPlayers[0].currLevelNum == LEVEL_CASTLE then
        warp_to_start_level()
        return false
    end
end

hook_event(HOOK_ON_LEVEL_INIT, on_level_init)
hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_UPDATE, update_timers)
hook_event(HOOK_ON_WARP, on_warp)