if not is_game_single_player then return end

function mod_storage_save_event()
    mod_storage_save_bool('destroyed_factory', big_events_table.wegas_factory_destroyed)
    mod_storage_save_bool('killed_golden_sigma', big_events_table.golden_sigma_killed)
    mod_storage_save_bool('beaten_game', big_events_table.maltiga_defeated)
end

function clear_mod_storage()
    mod_storage_save_bool('destroyed_factory', false)
    mod_storage_save_bool('killed_golden_sigma', false)
    mod_storage_save_bool('beaten_game', false)

    big_events_table.wegas_factory_destroyed = false
    big_events_table.golden_sigma_killed = false
    big_events_table.maltiga_defeated = false
end

local function mods_loaded()
    local mod_storage_1 = mod_storage_load_bool('destroyed_factory')
    local mod_storage_2 = mod_storage_load_bool('killed_golden_sigma')
    local mod_storage_3 = mod_storage_load_bool('beaten_game')

    if mod_storage_1 then
        big_events_table.wegas_factory_destroyed = mod_storage_1
    end

    if mod_storage_2 then
        big_events_table.golden_sigma_killed = mod_storage_2
    end

    if mod_storage_3 then
        big_events_table.maltiga_defeated = mod_storage_3
    end
end

hook_event(HOOK_ON_MODS_LOADED, mods_loaded)