if not is_game_single_player then return end

FE_JUST_A_MILE_AWAY = audio_stream_load("fe_just_a_mile_away.ogg")
WEGALOVANIA_START = audio_stream_load("wegalovania_start.ogg")
THE_ULTIMATE_TROLL = audio_stream_load("trollface_amaze.ogg")
GOLDEN_BOSSFIGHT = audio_stream_load("golden_bossfight.ogg")
BREAK_A_FACTORY = audio_stream_load("break_a_factory.ogg")
PATHETIC_LUIGI = audio_stream_load("pathetic_luigi.ogg")
WEGALOVANIA_V1 = audio_stream_load("wegalovania_v1.ogg")
WEGALOVANIA_LOOP = audio_stream_load("wegalovania.ogg")
GOLDEN_DEFEAT = audio_stream_load("golden_defeat.ogg")
CASTLE_SONG = audio_stream_load("stupid_castle.ogg")
WEGA_SPOOKY = audio_stream_load("wega_spooky.ogg")
EXTRAS_MENU = audio_stream_load("extras_menu.ogg")
GOLDEN_TALK = audio_stream_load("golden_talk.ogg")
WEGA_CHASE = audio_stream_load("wega_chase.ogg")
MAIN_MENU = audio_stream_load("main_menu.ogg")
ISLAND = audio_stream_load("island.ogg")
BONUS = audio_stream_load("bonus.ogg")

audio_stream_set_looping(FE_JUST_A_MILE_AWAY, true)
audio_stream_set_looping(THE_ULTIMATE_TROLL, true)
audio_stream_set_looping(MAIN_MENU, true)

local music_volume = 1

local fade_table = {}

music_table = {
    {song = FE_JUST_A_MILE_AWAY, display_info = nil},
    {song = WEGALOVANIA_START, display_info = nil},
    {song = THE_ULTIMATE_TROLL, display_info = {name = 'THE ULTIMATE TROLL', desc = 'Unused song intended to be for a secret Trollface battle.'}},
    {song = WEGA_SPOOKY, display_info = {name = 'Wega Spooky', desc = 'Unused song intended to be for a 3rd level.'}},
    {song = BONUS, display_info = {name = 'Bonus', desc = 'Unused song intended to be for a bonus sub-level.'}},
    {song = GOLDEN_BOSSFIGHT, display_info = {name = 'Golden Bossfight', desc = 'Plays during the fight with Golden Sigma.'}},
    {song = BREAK_A_FACTORY, display_info = {name = 'Break A Factory!', desc = 'Plays during The Factory.'}},
    {song = PATHETIC_LUIGI, display_info = {name = 'Pathetic Luigi', desc = 'Plays when you talk to Wega before the final battle.'}},
    {song = WEGALOVANIA_V1, display_info = {name = 'WEGALOVANIA [Old]', desc = 'Wegalovania before i decided to remake it.'}},
    {song = WEGALOVANIA_LOOP, display_info = {name = 'WEGALOVANIA', desc = 'Plays during the end fight with Maltiga.'}},
    {song = GOLDEN_DEFEAT, display_info = {name = 'Golden defeat.', desc = 'Plays in the end speech after you kill Golden Sigma.'}},
    {song = CASTLE_SONG, display_info = {name = 'Castle', desc = 'Plays when your in the castle.'}},
    {song = EXTRAS_MENU, display_info = {name = 'Extras Menu', desc = 'Plays in the extras menu, Originally intended to be a credits song.'}},
    {song = GOLDEN_TALK, display_info = {name = 'Golden Talk', desc = 'Plays when your talking to Golden Sigma before the battle.'}},
    {song = WEGA_CHASE, display_info = nil},
    {song = MAIN_MENU, display_info = nil},
    {song = ISLAND, display_info = {name = 'island', desc = 'Plays in the level after you fail to break all of Wega\'s machines in The Factory.'}},
}

function stop_all_music()
    for i = 1, #music_table do
        audio_stream_stop(music_table[i].song)
    end
end

function fade_out_stream(song, duration)
    table.insert(fade_table, {song = song, duration = duration, timer = 1, start_volume = audio_stream_get_volume(song)})
end

local function music_stuff()
    local m = gMarioStates[0]

    if gNetworkPlayers[0].currLevelNum == LEVEL_WF then
        if level_timer == 321 then
            audio_stream_play(WEGALOVANIA_LOOP, false, 1)
        end
    end

    if gNetworkPlayers[0].currLevelNum == LEVEL_SA then
        if level_timer == (32 * 30) then
            audio_stream_play(WEGA_CHASE, true, 2)
        end
    end

    if audio_stream_get_position(WEGALOVANIA_LOOP) > 96 then
        audio_stream_set_position(WEGALOVANIA_LOOP, audio_stream_get_position(WEGALOVANIA_LOOP) - 96)
    end

    if audio_stream_get_position(CASTLE_SONG) >= 96 then
        audio_stream_set_position(CASTLE_SONG, audio_stream_get_position(CASTLE_SONG) - 48)
    end

    if audio_stream_get_position(WEGA_CHASE) >= 11.70 then
        audio_stream_set_position(WEGA_CHASE, audio_stream_get_position(WEGA_CHASE) - 11.70)
    end

    if audio_stream_get_position(PATHETIC_LUIGI) >= 64 then
        audio_stream_set_position(PATHETIC_LUIGI, audio_stream_get_position(PATHETIC_LUIGI) - 64)
    end

    if audio_stream_get_position(GOLDEN_BOSSFIGHT) >= (42 + (2 / 3)) then
        audio_stream_set_position(GOLDEN_BOSSFIGHT, audio_stream_get_position(GOLDEN_BOSSFIGHT) - ((42 + (2 / 3))  - (10 + (2 / 3))))
    end

    if audio_stream_get_position(EXTRAS_MENU) >= 53 + (1 / 3) then
        audio_stream_set_position(EXTRAS_MENU, audio_stream_get_position(EXTRAS_MENU) - (53 + (1 / 3)))
    end

    if audio_stream_get_position(GOLDEN_TALK) >= 10 + (2 / 3) then
        audio_stream_set_position(GOLDEN_TALK, audio_stream_get_position(GOLDEN_TALK) - (10 + (2 / 3)))
    end

    if gNetworkPlayers[0].currLevelNum == LEVEL_DDD then
        if m.pos.z >= 1000 then
            music_volume = approach_f32(music_volume, 0, 0.05, 0.03)
        else
            music_volume = approach_f32(music_volume, 1, 0.05, 0.03)
        end
    end

    audio_stream_set_volume(CASTLE_SONG, music_volume)
    audio_stream_set_volume(FE_JUST_A_MILE_AWAY, ((-music_volume) + 1) / 4)

    for i = 1, #fade_table do
        local element = fade_table[i]

        if element then
            element.timer = element.timer + 1

            audio_stream_set_volume(element.song, element.start_volume - ((element.start_volume / element.duration) * element.timer))

            if element.timer >= element.duration then
                audio_stream_stop(element.song)
                table.remove(fade_table, i)
            end
        end
    end
end

local function level_init()
    local level = gNetworkPlayers[0].currLevelNum

    if level == LEVEL_JRB then
        audio_stream_play(MAIN_MENU, true, 1)
    end
end

hook_event(HOOK_UPDATE, music_stuff)
hook_event(HOOK_ON_LEVEL_INIT, level_init)