if not is_game_single_player then return end

textbox = nil

local textbox_char = 1
local timer = 0

MALTIGA_VOICE = audio_sample_load('maltiga_talk.ogg')
NORMAL_VOICE = audio_sample_load('normal_talk.ogg')

TEX_TROLLFACE = get_texture_info("trollface")

function create_textbox(msg, special)
    textbox = {
        textbox_string = msg,
        textbox_special = special,
    }

    cutscene_timer_pause = true
    textbox_char = 1
end

local function get_delay_multiplier(character)
    if character == "," then
        return 2
    elseif character == "." then
        return 4
    elseif character == "?" then
        return 16
    else
        return 1
    end
end

local function on_hud_render()
    djui_hud_set_resolution(RESOLUTION_N64)
    local width, height = djui_hud_get_screen_width(), djui_hud_get_screen_height()
    local half_width = width / 2

    djui_hud_set_font(FONT_NORMAL)

    if textbox then
        local width_offset, line = 0, 0

        timer = timer + 1
        djui_hud_set_color(0, 0, 0, 255)
        djui_hud_render_rect(half_width - 128, height - 72, 256, 64)

        djui_hud_set_color(255, 255, 255, 255)
        djui_hud_render_rect(half_width - 128, height - 72, 256, 2)
        djui_hud_render_rect(half_width - 128, height - 10, 256, 2)
        djui_hud_render_rect(half_width - 128, height - 72, 2, 64)
        djui_hud_render_rect(half_width + 126, height - 72, 2, 64)

        local y_offset_base = height - 56

        if textbox.textbox_special == 1 then
            for i = 1, clampf(textbox_char, 0, string.len(textbox.textbox_string)) do
                local current_character = string.sub(textbox.textbox_string, i, i)

                if current_character == ">" then
                    width_offset = 0
                    line = line + 1
                    current_character = string.lower(string.sub(textbox.textbox_string, i + 1, i + 1))
                elseif current_character == "=" then
                    local y_offset = y_offset_base - 6 + line * 12
                    djui_hud_render_texture(TEX_TROLLFACE, (half_width - (128 - 8) + width_offset) + (math.random(-1, 1) / 4), (y_offset) + (math.random(-1, 1) / 4), 0.25, 0.25)
                elseif current_character ~= " " then
                    local y_offset = y_offset_base - 6 + line * 12
                    djui_hud_print_text(current_character, (half_width - (128 - 8) + width_offset) + (math.random(-1, 1) / 4), (y_offset) + (math.random(-1, 1) / 4), 0.5)
                    width_offset = width_offset + (djui_hud_measure_text(current_character) / 2)
                else
                    width_offset = width_offset + 6
                end

                if i == textbox_char then
                    if current_character:match("[%a%d]") then

                        audio_sample_play(MALTIGA_VOICE, gLakituState.pos, 1)
                    end
                end
            end
        else
            for i = 1, clampf(textbox_char, 0, string.len(textbox.textbox_string)) do
                local current_character = string.sub(textbox.textbox_string, i, i)

                if current_character == ">" then
                    width_offset = 0
                    line = line + 1
                    current_character = string.lower(string.sub(textbox.textbox_string, i + 1, i + 1))
                elseif current_character ~= " " then
                    local y_offset = y_offset_base - 6 + line * 12
                    djui_hud_print_text(current_character, (half_width - (128 - 8) + width_offset), (y_offset), 0.5)
                    width_offset = width_offset + (djui_hud_measure_text(current_character) / 2)
                else
                    width_offset = width_offset + 6
                end

                if i == textbox_char then
                    if current_character:match("[%a%d]") then

                        audio_sample_play(NORMAL_VOICE, gLakituState.pos, 0.15)
                    end
                end
            end
        end

        if timer % get_delay_multiplier(string.lower(string.sub(textbox.textbox_string, textbox_char, textbox_char))) == 0 then
            textbox_char = textbox_char + 1
        end
    else
        timer = 0
    end
end

hook_event(HOOK_ON_HUD_RENDER, on_hud_render)
